<!--
 * @Descripttion: 
 * @version: 
 * @Author: auth
 * @Date: 2021-03-08 16:34:13
 * @LastEditors: pangkangrong-123 973534209@qq.com
 * @LastEditTime: 2022-05-25 12:27:06
-->
### **my-dialog 调用方式**
```Vue
<template>
    <my-banner :header-date="headerDate" @watchCallback="listHeaderCb">
    </my-banner>
</template>
<script>
    data() {
        return {
            headerDate: {
                backgroundImgUrl: require("@/assets/imgs/template.png"), //背景图
                name: "仓库管理", // 头部左边显示名
                btnList: [
                {
                    name: "新建仓库",
                    show: true, //显示隐藏
                    icon: "sub_color el-icon-plus", //icon
                    iconParams: "", //icon自定义显示
                    clickName: "newDepository" //点击按钮返回操作名称标识名
                }
                ],
                // 列表的搜索栏部分配置
                toolList: {
                // show: true,
                list: [
                    {
                    span: 8, //占比  总数24
                    // offset:0
                    items: [
                        {
                        type: "text",
                        // show: true,
                        span: 12,
                        name: "仓库列表" //搜索栏左边的列表标题
                        }
                    ]
                    },
                    {
                    justify: "end", //el-row的对齐方式
                    span: 16,
                    // offset:0
                    items: [
                        // {
                        // type: "radio-group",
                        // model: "rr",
                        // clickName: "rrr",
                        // labelOrName: {
                        //     label: "label",
                        //     name: "value"
                        // },
                        // list: [
                        //     {
                        //     label: "全部",
                        //     value: "subjectName"
                        //     },
                        //     {
                        //     label: "启用",
                        //     value: "contractName"
                        //     },
                        //     {
                        //     label: "禁用",
                        //     value: "contractNo"
                        //     }
                        // ]
                        // },
                        {
                        type: "date",
                        label: "申请日期",
                        span: 4,
                        placeholder: "请选择",
                        model: "date1"
                        },
                        {
                        type: "date",
                        label: "~",
                        span: 4,
                        placeholder: "请选择",
                        model: "date2"
                        },
                        {
                        type: "inputSelect",
                        span: 10,
                        clickName: "searchBtn", //按钮返回事件唯一辨识
                        inputPlaceholder: "请输入",
                        inputModel: "searchTxt", //输入框的值
                        // inputStyle: "", //输入框
                        selectPlaceholder: "请选择",
                        selectModel: "searchType", //下拉列表的值
                        // selectStyle: "width:100px;", //下拉列表
                        showClick: true, //显示内置的按钮
                        labelOrName: {
                            label: "label",
                            name: "value"
                        },
                        list: [
                            {
                            label: "全部",
                            value: "subjectName"
                            },
                            {
                            label: "启用",
                            value: "contractName"
                            },
                            {
                            label: "禁用",
                            value: "contractNo"
                            }
                        ]
                        }
                        // {
                        //   type: "customButton",
                        //   buttonName: "导出",
                        //   clickeName: "export",
                        //   class: "danger"
                        // }
                    ]
                    }
                ]
                },
                moreConditions: [
                {
                    type: "date",
                    label: "申请日期",
                    span: 4,
                    placeholder: "请选择",
                    class: "right",
                    model: "date3"
                },
                {
                    type: "date",
                    label: "~",
                    span: 4,
                    placeholder: "请选择",
                    model: "date4"
                },
                {
                    type: "date",
                    label: "申请日期",
                    span: 4,
                    placeholder: "请选择",
                    class: "right",
                    model: "date3"
                },
                {
                    type: "date",
                    label: "~",
                    span: 4,
                    placeholder: "请选择",
                    model: "date4"
                },
                {
                    type: "date",
                    label: "申请日期",
                    span: 4,
                    placeholder: "请选择",
                    class: "right",
                    model: "date3"
                },
                {
                    type: "date",
                    label: "~",
                    span: 4,
                    placeholder: "请选择",
                    model: "date4"
                }
                ],
                tableToolForm: {
                searchTxt: "",
                date1: ""
                }
            }
        };
    },
    methods: {
        listHeaderCb(params) {
            console.log(params); 
        }
    }
</script>
```
> ps：my-dialog可嵌套使用，取消按钮默认点击即可关闭弹窗

### **Attributes**

属性|说明|类型|可选值|默认值
:-|:-|:-|:-|:-
btnList|banner右上角的按钮|object|-|-
toolList|banner下面的搜索条件字段|
moreConditions|可展开的搜索条件|Array

### **headerDate.list.items**
查询字段配置
属性|说明|类型|可选值|默认值
:-|:-|:-|:-|:-
type|字段显示类型|String|'searchButton','text','customButton','input','radio-group','inputSelect','inputSearch','select','daterange','date', 'month', 'year', 'dates'|-
clickName|回调方法名字|sting
model|字段值|
span|字段的el-col的栅格占据的列数
gutter|字段的间距|Number||10
itemsSpan|items的span值|Number||8
required|是否必填，如不设置，则会根据校验规则自动生成|boolean，function||
formLabelShow|是否使用formItem的lable|||
labelWidth|表单域标签的的宽度|string||
rowType|布局模式type的值，可选 flex,|String||flex
style|