<!--
 * @Descripttion: 
 * @version: 
 * @Author: auth
 * @Date: 2021-03-08 16:34:13
 * @LastEditors: auth
 * @LastEditTime: 2021-03-15 09:10:28
-->
### **my-dialog 调用方式**
```Vue
<template>
    <my-dialog
        :dialogTitle.sync="dialogTitle"
        :dialogVisible.sync="dialogVisible"
        :confirmCss="{ background: '#081f5b' }"
        :footerBtnPosition="'left'"
        @handleConfirm="handleConfirm"
    >
        <div slot="modal-search">
        <el-input size="small"></el-input>
        </div>
        <span ref="dialogRef" slot="modal-body">111111111111111111111111111</span>
    </my-dialog>
</template>
<script>
    data() {
        return {
            dialogTitle: "测试弹窗",
            dialogVisible: false
        };
    },
    methods: {
        handleConfirm() {
            // this.dialogVisible = false;
            console.log("--", this.$refs);
        }
    }
</script>
```
> ps：my-dialog可嵌套使用，取消按钮默认点击即可关闭弹窗

### **Attributes**

属性|说明|类型|可选值|默认值
:-|:-|:-|:-|:-
dialogTitle|标题|String|-|-
dialogVisible|是否显示，支持 .sync 修饰符|Boolean|true/false|false
dialogWidth|宽度|String|% 或px|65%
isDialogFooter|是否显示脚步按钮|Boolean|true/false|true
footerBtnPosition|按钮位置|String|left/center/right|center
confirmCss|确认按钮样式|Object|-|background: '#081f5b'
close-on-click-modal|是否可以通过点击 modal 关闭 Dialog|Boolean|true/false|false
submitBtnText|确定按钮的文字|String|-|-
submitBtnVisible|是否显示确定按钮|Boolean|true/false|true
cancelBtnText|取消按钮的文字|String|-|-
cancelBtnVisible|是否显示取消按钮|Boolean|true/false|true
submitBtnLoading|确定按钮的loading控制|Boolean|true/false|false
propAttributes|弹窗的属性集合|Object|-|-
||||
### **events**
事件|说明|回调参数
:-|:-|:-
handleIconClose|取消或关闭弹窗的回调|-
handleConfirm|确认事件的回调，业务处理|-
||
### **slot**
name|说明
:-|:-
modal-search| 头部右侧插槽的内容
modal-body|弹窗主体的内容
modal-footer|脚部的内容