
### **my-form 调用方式**
```
<template>
  <div class="">
    <xForm
      ref="xForm"
      :formDataConfig="formDataB"
      @watchCallBackFun="watchCallBackFun"
    >
      <template slot="selfSlot">
        <h1>自定义插槽</h1>
      </template>
      <template slot="accTable">
        <h1>自定义插槽2</h1>
      </template>
    </xForm>
  
  </div>
</template>
```

> my-forms Attributes
# ** my-forms Attributes**
参数|说明|类型|可选值|默认值
-|:-|:-|:-|:-
formDataConfig|form的配置|object|-|-
watchCallBackFun|form回调函数，组件事件配置为string的时候 触发此事件|function|-|回调参数 {name:"事件名称",list:{form数据}，defaultCallBackData:【默认事件所有参数都放在此字段】}
> my-forms Attributes
## ** my-forms-formDataConfig**
参数|说明|类型|可选值|默认值
-|:-|:-|:-|:-
formItemDisabled|开启全局的disabled控制|Boolean/function|-|-
labelWidth|表单域标签的宽度|string|-|100px
gutter|form元素之间的间距|number|-|80
form|form表单的所有model的值，可在此配置默认值|object|require|object
headerConfig|头部按钮和标题配置|object|-|-
formConfig|form表单配置|array/object|require|-
formFootConfig|form底部操作按钮配置|object|-|-

## ** my-forms-headerConfig Attributes**
参数|说明|类型|可选值|默认值
-|:-|:-|:-|:-
show|是否加载|Boolean|true/false|false
list|配置项|object/array|-|-

### ** my-forms-headerConfig-list 配置项每一个item说明 Attributes**
参数|说明|类型|可选值|默认值
-|:-|:-|:-|:-
show|是否加载|Boolean|true/false|-
justify|位置|string|left/center/right|-
span|栅格占据的列数|number|-|8
offset|栅格左侧的间隔格数|number|-|-
list|每一项具体配置，目前可配置按钮和标题|object|-|-

### ** my-forms-headerConfig-list-list 配置项每一个item说明 Attributes**
参数|说明|类型|可选值|默认值
-|:-|:-|:-|:-
show|是否加载|Boolean|true/false|-
xType|加载组件的类型|string|button/text|-|-
label| xType= "text"，显示的标题|string|-|-
text|xType: "button"，显示的按钮名称|string|-|-
linkType|文字使用el-link|string|primary/success/warning/danger/info|默认使用button文字
click|xType: "button",点击事件|function|-|-
eicon|使用elementUI图标|string|-|-
icon|使用iconfont图标|string|-|-
其他..|xType: "button" ，参考 elementUI Button 按钮


## ** my-forms-formConfig Attributes**
formConfig配置对象，每一个对象配置如下
参数|说明|类型|可选值|默认值
-|:-|:-|:-|:-
show|是否加载|Boolean|true/false|true
model|如果form表单不是都同一个层级（二级form）可单独为formConfig的每一个item配置一个单独的
model,则list下每一个子项的model都会放在里面，为了防止报错，在form里面需要默认配置model的一个空对象，示例请看xForm.vue页面配置|object|-|-
modelChildren|三级form，需要配合model使用|array/object|-|-
bodyStyle|card style的样式 自定义
enableSelfDisabled|解绑formItemDisabled全局的disabled控制，开启后，每一个disabled自己控制自己|Boolean/function|-|-
noBorder|去除card的border|Boolean|true/false|false
cardShadow|设置阴影显示时机|string|always / hover / never|always
titleConfig|配置card左边显示，class:{},show:Boolean是否加载；slot："插槽名称"，直接使用插槽配置；leftBorderShow：Boolean；蓝色边显示；text：string,标题；subtext：string:副标题；
headerRightConfig|配置card右边显示 show：Boolean，list:{组件配置，参考组件配置}|object|-|-
slot|使用插槽|string|-|-
list|组件配置，参考组件配置,有slot情况下不加载list配置，

## ** my-forms-formFootConfig Attributes**

参数|说明|类型|可选值|默认值
-|:-|:-|:-|:-
show|是否加载|Boolean|true/false|false
list|配置项|object/array|-|-
class|自定义样式|String
### ** my-forms-formFootConfig-list 配置项每一个item说明 Attributes**
参数|说明|类型|可选值|默认值
-|:-|:-|:-|:-
show|是否加载|Boolean|true/false|-
justify|位置|string|left/center/right|-
span|栅格占据的列数|number|-|8
offset|栅格左侧的间隔格数|number|-|-
list|每一项具体配置|object|-|-


# ** 所有组件配置 Attributes**

参数|说明|类型|可选值|默认值
-|:-|:-|:-|:-
show|是否加载|Boolean|true/false|-
disabled|禁止操作状态|Boolean/function|-|false
enableSelfDisabled|是否开启自生的disabled，不受全局控制|Boolean/function|-|false
xType|组件类型|string|button/input/select/datePicker/autocomplete/cascader/radio/checkbox/colorPicker/inputNumber/rate/slider/switch/timePicker/timeSelect/progress/upload/tabs/transfer/tree/tag|-
name|xType:slot,代表插槽的名字|string|-|-
model|form表单model配置|string|-|-
rules|校验规则配置，保持和element一致,required 字段类型可为boolean/function[返回值为配置本身],其他与elementUI配置项不一一写出来，可参考elementUI;|array
style|style配置|-|-|-
labelLineFeed|label文字换行配置|Boolean|-|-
valueType|xType: "input"情况下，数字转金额或者数字显示，保留两位小数,只能输入数字;xType: "select"时，valueType='object',选中为对象|string|money/number/object|-
prefixIcon|首部icon|-
suffixIcon|尾部icon|-
slotsuffix|自定义末尾标识名称|string|-|-
dic|配置下拉或者tree等数据源|array/object/function|注意// 配置1dic: { label: "name", value: "id",data: []},//配置2/dic:{label: "name",value: "id",data:(model)=>{return []}}//配置3dic:[],/配置4/dic:(model)=>{return []},|-
事件名称(例如click等等)|可配置function或者string;配置成string 则配置watchCallBackFun 回调 {name:"事件名称",list:{form数据}，defaultCallBackData:【默认事件所有参数都放在此字段】}
注意|form组件里面定义一个方法 formateOutFormMoneyToNum，此方法返回form表单数据，所有涉及到金额的 都会自动还原成数字返回，不影响form表单页面数据；form组件方法validate（fn）；resetFields（）；clearValidate（）,校验，手动调用。|-|-
其他配置|和elementUI配置保持一直，请参考对应elementUI的组件配置即可；tabs 卡片配置有插槽，可看示例;|-|-
linkType|xType=button,文字使用el-link|string|primary/success/warning/danger/info/default|默认使用button文字
click|xType=button,xType: "button",点击事件|function|-|-
eicon|xType=button,使用elementUI图标|string|-|-
icon|xType=button,使用iconfont图标|string|-|-
pickerOptions|xDatePicker xTimePicker xTimeSelect 的pickerOptions属性|object/function|-
tooltip|label前面图标提示配置|Object/function|属性有show/icon/eicon/content/type/style；show/content可配置方法，返回值是object，包含有表单form和model字段;icon使用iconfont图标，eicon 使用element icon图标；type el-link的配置色|-

enableSelfModel|是否开启自己的form的model层级，不受全局model/modelChildren的影响|Boolean/function|-|false
levelModel|enableSelfModel为true form的一级对象|object|-|-
modelChildren|enableSelfModel为true，需要配合levelModel使用|array/object|-|-
