<!--
 * @Descripttion: 
 * @version: 
 * @Author: auth
 * @Date: 2021-06-02 14:57:22
 * @LastEditors: auth
 * @LastEditTime: 2021-08-06 14:59:06
-->

### **my-header 调用方式**
```Vue
<template>
    <my-header :headerData="headerData" @headerCallback="headerCallback"></my-header>
</template>
<script>
    data() {
        return {
            headerData: {}
        };
    },
    methods: {
        headerCallback(params) {
            switch (params.eventName) {
                case "handleHome":
                    console.log("点击首页");
                    break;
                case "handleLogOut":
                    console.log("登出");
                    break;
                case "handleReset":
                    console.log("修改密码");
                    break;
                case "handleLink":
                    console.log("跳转系统菜单");
                    break;
            }
        },
    }
</script>
```

### **Attributes**

属性|说明|类型|可选值|默认值|是否必填|
:-|:-|:-|:-|:-|:-
headerData|参数集合|Object|-|-|true
headerData.logoUrl|logo的路径|String|-|-|true
headerData.logoName|logo名称|String|-|-|true
headerData.logoEventName|点击logo时的事件名称|String|-|-|true
headerData.topMenusIcon|左上角图标自定义类名，不填不显示|String|-|-|false
headerData.topMenusIconStyle|左上角图自定义样式，不填不显示|String|-|-|false
headerData.logoDivider|logo图标和文字之间的分割线|Boolean|true/false|false|true
headerData.iconList|右侧icon图标列表|Array|-|-|true
headerData.iconList[0].iconClass|图标类名|String|-|-|true
headerData.iconList[0].eventName|事件名称|String|-|-|true
headerData.iconList[0].showBadge|是否显示标记|String|-|-|true
headerData.logOut|登出信息集合|Object|-|-|true
headerData.logOut.imgUrl|头像路径|String|-|-|true
headerData.logOut.userName|用户名|String|-|-|true
headerData.logOut.popoverList|登出选项列表|Array|-|-|true
headerData.logOut.popoverList[0].iconClass|图标类名|String|-|-|true
headerData.logOut.popoverList[0].name|选项名称|String|-|-|true
headerData.logOut.popoverList[0].pointer|是否可点击|Boolean|true/false|false|true
headerData.logOut.popoverList[0].showDivider|是否显示分割线|Boolean|true/false|false|true
headerData.logOut.popoverList[0].eventName|事件名称|String|-|-|true
headerData.popoverShow|是否显示菜单的弹出窗|Boolean|true/false|false|false
headerData.topMenu|左侧菜单列表|Array|-|-|true
headerData.topMenu[0].id|菜单id|Number|-|-|true
headerData.topMenu[0].menuName|菜单名称|String|-|-|true
headerData.topMenu[0].path|菜单路由|String|-|-|true
headerData.topMenu[0].icon|菜单图标类名|String|-|-|true
headerData.topMenu[0].isShow|是否显示菜单|Boolean|0/1|-|true
headerData.topMenu[0].origin|项目地址|String|-|-|true
headerData.topMenu[0].iconUrl|菜单图标路径地址|String|-|-|true

### **events**
事件|说明|回调参数
:-|:-|:-
headerCallback|事件的回调|params

