# my-upload

### my-upload 调用方式**
``` Vue
  <template>
          <ElUpload
            @handleSuccess="handleSuccess"
            @handlePreview="handlePreview"
            @handleExceed="handleExceed"
            @handleRemove="handleRemove"
            @uploadProcess="uploadProcess"
            :url="url"
          />
      </template>
<script>
 export default {
    data() {
      return {
           url: uploadUrl,//附件上传路径
      }
    },
      methods: {	
        handleSuccess(response, file, fileList) {
          console.log("handleSuccess",response, file, fileList)
      },
        handlePreview(file) {
           console.log("handlePreview",file)
      },
        handleExceed(files, fileList) {
          console.log("handleExceed",files, fileList)
      },
       handleRemove(file, fileList) {
          console.log("handleRemove",file, fileList)
      },
       uploadProcess(event, file, fileList){
          console.log("handleSuccess",event, file, fileList)
          }
    },
  }
</script>
```


### **item内置属性**
属性|说明|备注
:-|:-|:-
multiple|是否支持多选文件|默认true
show-file-list|是否显示列表|默认false
handleExceed|当前限制选择文件数量|-
boforUpload|上传文件黑名单|默认"bat", "asp", "jsp", "exe", "EXE"

### **Attributes**
> 若属性不传即使用默认值，建议传入数据源时最好判断下数据源

属性|说明|类型|可选值|默认值
:-|:-|:-|:-|:-
 url  | 附件上传路径 | -    |        |        

### **events**

事件|说明|回调参数
:-|:-|--
handlePreview|点击文件列表中已上传的文件时的钩子|file
handleExceed|文件超出个数限制时的钩子|files, fileList
uploadProcess|文件上传时的钩子|event, file, fileList
handleRemove|文件列表移除文件时的钩子|event, file, fileList
handleSuccess|上传成功的回调|event, file, fileList

