/*
 * @Author: your name
 * @Date: 2021-07-12 10:13:24
 * @LastEditTime: 2022-06-10 18:41:10
 * @LastEditors: pangkangrong-123 973534209@qq.com
 * @Description: In User Settings Edit
 * @FilePath: \fe-component-lib\src\common\js\defaultFunction.js
 */
//合并对象方法
export function merge(target) {
  // console.log("target11", Object.keys(target).length);
  // console.time(11);
  // console.log("arguments.length", arguments.length);
  /* */
  for (let i = 1, j = arguments.length; i < j; i++) {
    // console.log({ name: 2222 }.hasOwnProperty.call("name"));
    let source = arguments[i] || {};
    for (let prop in source) {
      // source.hasOwnProperty(prop) 3  禁止此方法
      // 替换成 Object.prototype.hasOwnProperty.call(source,prop)
      if (Object.prototype.hasOwnProperty.call(source, prop)) {
        let value = source[prop];
        if (value !== undefined) {
          target[prop] = value;
        }
      }
    }
  }
  // console.timeEnd(11);
  // console.log("target22", target);
  return target;
}

// 获取动态组件类型
export function getComponentType(configItem) {
  // console.time("获取动态组件类型");
  const xType = configItem.xType;
  // const type = configItem.type;
  const typeObj = {
    slot: "slot",
    cascader: "MyCascader",
    checkbox: "MyCheckbox",
    colorPicker: "MyColorPicker",
    datePicker: "MyDatePicker",
    datePickerRange: "MyDaterange",
    input: "MyInput",
    autocomplete: "MyAutocomplete",
    inputNumber: "MyInputNumber",
    radio: "MyRadio",
    rate: "MyRate",
    select: "MySelect",
    selecttree: "MySelectTree",
    slider: "MySlider",
    switch: "MySwitch",
    timePicker: "MyTimePicker",
    timePickerRange: "MyDaterange",
    timeSelect: "MyTimeSelect",
    timeSelectRange: "MyDaterange",
    transfer: "MyTransfer",
    tree: "MyTree",
    progress: "MyProgress",
    upload: "MyUpload",
    button: "MyButton",
    tabs: "MyTabs",
    tag: "MyTag"
  };
  return typeObj[xType];
  // if (xType === "slot") {
  //   return "slot";
  // } else if (xType === "cascader") {
  //   return "MyCascader";
  // } else if (xType === "checkbox") {
  //   return "MyCheckbox";
  // } else if (xType === "colorPicker") {
  //   return "MyColorPicker";
  // } else if (xType === "datePicker") {
  //   return "MyDatePicker";
  // } else if (xType === "input") {
  //   return "MyInput";
  // } else if (xType === "autocomplete") {
  //   return "MyAutocomplete";
  // } else if (xType === "inputNumber") {
  //   return "MyInputNumber";
  // } else if (xType === "radio") {
  //   return "MyRadio";
  // } else if (xType === "rate") {
  //   return "MyRate";
  // } else if (xType === "select") {
  //   if (type === "selecttree") {
  //     return "MySelectTree";
  //   }
  //   return "MySelect";
  // } else if (type === "selecttree") {
  //   return "MySelectTree";
  // } else if (xType === "slider") {
  //   return "MySlider";
  // } else if (xType === "switch") {
  //   return "MySwitch";
  // } else if (xType === "timePicker") {
  //   return "MyTimePicker";
  // } else if (xType === "timeSelect") {
  //   return "MyTimeSelect";
  // } else if (xType === "transfer") {
  //   return "MyTransfer";
  // } else if (xType === "tree") {
  //   return "MyTree";
  // } else if (xType === "progress") {
  //   return "MyProgress";
  // } else if (xType === "upload") {
  //   return "MyUpload";
  // } else if (xType === "button") {
  //   return "MyButton";
  // } else if (xType === "tabs") {
  //   return "MyTabs";
  // } else if (xType === "tag") {
  //   return "MyTag";
  // }
}
// 金额添加千分位
/**
 *
 * @param {*} n 传入数字
 * @param {*} autoFixed  有标识的时候保留数据原格式 只添加千分符
 * @returns
 */
export function comdify(n, autoFixed = null) {
  if (n === "0" || n === 0) {
    return "0.00";
  }
  if (!n) return n;
  if (typeof n == "number") {
    n += "";
  } else if (!Number(n)) {
    return n;
  }

  let str = n.split(".");
  let re = /\d{1,3}(?=(\d{3})+$)/g;
  let n1 = str[0].replace(re, "$&,");
  if (autoFixed != undefined) {
    return str.length > 1 && str[1] ? `${n1}.${str[1]}` : `${n1}`;
  } else {
    return str.length > 1 && str[1]
      ? `${n1}.${str[1] && str[1].length == 1 ? str[1] + "0" : str[1]}`
      : `${n1}.00`;
  }
}
/**
 * 将number保留bitNum位小数，不够补0
 * @param number
 * @param bitNum
 * @returns {string|number}
 */
export function changeDecimal(number, bitNum) {
  var f_x = parseFloat(number);
  if (isNaN(f_x)) {
    return 0;
  }
  var s_x = number.toString();
  var pos_decimal = s_x.indexOf(".");
  //没有小数点的加上小数点
  if (pos_decimal < 0) {
    pos_decimal = s_x.length;
    if (bitNum != 0) {
      s_x += ".";
    } else {
      //没有小数点还要保留0位小数
      return s_x;
    }
  }
  if (s_x.length <= pos_decimal + bitNum) {
    //eg:122 保留2位小数
    //return 122.00
    while (s_x.length <= pos_decimal + bitNum) {
      s_x += "0";
    }
  } else {
    //eg:1.222222  保留2位小数
    //return 1.22
    s_x = s_x.substring(0, pos_decimal + bitNum + 1);
  }
  return s_x;
}
//去除千分位中的","
export function delcommafy(num) {
  if (!num) return num;
  num = num.toString();
  num = num.replace(/,/gi, "");
  // if (!isNaN(num)) {
  return Number(num);
  // }
}
// 过滤特殊字符
/**
 *
 * @param {*} str  传入的字符串
 * @param {*} number 是否只能输入数字
 * @param {*} toFixedNum 保留几位小数
 * @param {*} toFixedStatus 是否四舍五入
 * @returns
 */
export function filterStr(str, number = false, toFixedNum, toFixedStatus) {
  if (str == undefined) {
    return;
  }
  let putStr = str;
  if (typeof str == "number") {
    putStr += "";
  }
  // console.log("putStr111", putStr);
  // 临时去掉
  // putStr = putStr.replace(/[`~!^&':;']/gi, "");
  // console.log("putStr2221", putStr);
  // var reg =  new RegExp('<[^>]+>','gi');  //过滤所有的html标签，不包括内容
  // var reg3 = /<(\S*)[^>]*>[^<]*<\/(\1)>/gi;        //分组匹配，过滤所有的html标签，包括内容
  // var reg3 = new RegExp('<(\\S*)[^>]*>[^<]*<\\/(\\1)>','gi');  //分组匹配，过滤所有的html标签，包括内容
  var regHtml = new RegExp("<(img|br|hr|input|script|alert)[^>]*>", "gi"); ////只匹配img、br、hr、input标签
  // let regHtml = /<\/?.+?>/g; //过滤html代码输入
  putStr = putStr.replace(regHtml, "");
  // 只能输入数字
  if (number) {
    //得到第一个字符是否为负号
    var t = putStr.charAt(0);
    //先把非数字的都替换掉，除了数字和.
    putStr = putStr.replace(/[^\d.]/g, "");
    //必须保证第一个为数字而不是.
    putStr = putStr.replace(/^\./g, "");
    //保证只有出现一个.而没有多个.
    putStr = putStr.replace(/\.{2,}/g, ".");
    //保证.只出现一次，而不能出现两次以上
    putStr = putStr
      .replace(".", "$#$")
      .replace(/\./g, "")
      .replace("$#$", ".");
    //如果第一位是负号，则允许添加
    if (t == "-") {
      putStr = "-" + putStr;
    }
    if (toFixedNum != undefined) {
      // console.log(putStr, toFixedNum, toFixedStatus);
      // console.log(Number(putStr).toFixed(2));
      if (toFixedStatus) {
        //开启四舍五入
        putStr = changeDecimal(
          Number(putStr).toFixed(Math.abs(toFixedNum)),
          Math.abs(toFixedNum)
        );
      } else {
        putStr = changeDecimal(Number(putStr), Math.abs(toFixedNum));
      }
    } else {
      putStr = Number(putStr);
    }
  }
  // console.log("putStr:", typeof putStr);
  return putStr;
  // console.log("$filterRegExp", this.$filterRegExp, str, number, model);
}
/**
 *
 * @param {*} fileByte  number 文件大小  返回字符串的文件大小
 * @returns
 */
export function getFileSize(fileByte) {
  if (!fileByte || typeof fileByte != "number") {
    return "";
  }
  var fileSizeByte = fileByte;
  var fileSizeMsg = "";
  if (fileSizeByte < 1048576)
    fileSizeMsg = (fileSizeByte / 1024).toFixed(2) + "KB";
  else if (fileSizeByte === 1048576) fileSizeMsg = "1MB";
  else if (fileSizeByte > 1048576 && fileSizeByte < 1073741824)
    fileSizeMsg = (fileSizeByte / (1024 * 1024)).toFixed(2) + "MB";
  else if (fileSizeByte > 1048576 && fileSizeByte == 1073741824)
    fileSizeMsg = "1GB";
  else if (fileSizeByte > 1073741824 && fileSizeByte < 1099511627776)
    fileSizeMsg = (fileSizeByte / (1024 * 1024 * 1024)).toFixed(2) + "GB";
  else fileSizeMsg = "文件超过1TB";
  return fileSizeMsg;
}

//判断样式是否存在
export function hasClass(ele, cls) {
  return ele.className.match(new RegExp("(\\s|^)" + cls + "(\\s|$)"));
}
//为指定的dom元素添加样式
function addClass(ele, cls) {
  if (!hasClass(ele, cls)) ele.className += " " + cls;
}
//删除指定dom元素的样式
function removeClass(ele, cls) {
  if (hasClass(ele, cls)) {
    var reg = new RegExp("(\\s|^)" + cls + "(\\s|$)");
    ele.className = ele.className.replace(reg, " ");
  }
}
//如果存在(不存在)，就删除(添加)一个样式
export function toggleClass(ele, cls) {
  if (hasClass(ele, cls)) {
    removeClass(ele, cls);
  } else {
    addClass(ele, cls);
  }
}

// 校验电话号码
export function checkPhone(mobile) {
  console.log(mobile, "++++", mobile.length);
  var tel = /^0\d{2,3}-?\d{7,8}$/;
  var phone = /^(((13[0-9]{1})|(15[0-9]{1})|(18[0-9]{1}))+\d{8})$/;
  if (mobile.length == 11) {
    //手机号码
    if (phone.test(mobile)) {
      // console.log(mobile);
      return true;
    }
  } else if (
    (mobile.length == 13 || mobile.length == 12) &&
    mobile.indexOf("-") != -1
  ) {
    //电话号码
    if (tel.test(mobile)) {
      // console.log(mobile);
      return true;
    }
  }
  // return false;
  // console.log("请输入有效的号码！");
}

// 计算文字的长度
/**
 * @text 字符串
 * @font 字体大小  默认14
 */
function getTextWidth(
  text,
  font = "14px Avenir, Helvetica, Arial, sans-serif"
) {
  // console.time("计算宽度");
  var canvas =
    getTextWidth.canvas ||
    (getTextWidth.canvas = document.createElement("canvas"));
  var context = canvas.getContext("2d");
  context.font = font;
  // context.fontFamily = family;
  var metrics = context.measureText(text);
  // console.log("metrics:", metrics);
  // console.timeEnd("计算宽度");
  if (metrics.width) {
    return Math.ceil(metrics.width);
  }
  return 0;
}
// 计算文字大小
/**
     * @str 字体
     * @size 大小 "14px"
     * @family 字体 "Avenir, Helvetica, Arial, sans-serif"
     * size = "14px",
      family = "Avenir, Helvetica, Arial, sans-serif"
     */
export function computeFontSize(str) {
  let strName = "";
  // 传进来是方法 有返回值
  if (typeof str === "function" && str() != undefined) {
    strName = str();
  } else {
    strName = str;
  }
  return getTextWidth(strName);
}
